#!/usr/bin/python3
import random
import sys

# Very wide rectangle with several long lines. 

m, s = map(int, sys.argv[1:3])
random.seed(s)
assert(m%2 == 0)

n = 250000//m

kmin = n
moves = []

for _ in range(m//2):
    k = random.randint(10,100)
    kmin = min(kmin,k)
    
    lo, hi = k, n-k-1
    perm = []
    while lo <= hi:
        if random.randint(0,1):
            perm.append(lo)
            lo += 1
        else:
            perm.append(hi)
            hi -= 1
    perm = perm[::-1]
    
    extras = list(range(k)) + list(range(n-k,n))
    extras += extras
    random.shuffle(extras)
    
    amoves = perm.copy()
    bmoves = perm.copy()
    for i in range(2*k):
        jb, ja = sorted(random.choices(range(len(amoves)+1), k=2))
        amoves.insert(ja, extras[2*i])
        bmoves.insert(jb, extras[2*i+1])
    
    moves += [x+1 for pr in zip(amoves,bmoves) for x in pr]

print(f'{m} {n} {n-2*kmin}')
print(' '.join(map(str, moves)))
