import java.util.*;
import java.io.*;

public class Paul {
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		String[] dims = br.readLine().split(" ");
		int h = Integer.valueOf(dims[0]);
		int w = Integer.valueOf(dims[1]);
		int k = Integer.valueOf(dims[2]);

		String[] moves = br.readLine().split(" ");
		int[] pos = new int[w];
		int[][] a = new int[h+2][w+2];
		for (int[] b: a) Arrays.fill(b, -1);
		
		int[][][] run = new int[h+2][w+2][8];
		for (int i = 0; i < h*w; i++) {
			int y = Integer.valueOf(moves[i]);
			int x = ++pos[y-1];
			a[x][y] = i%2;

			int dir = 0;
			for (int dx = -1; dx <= 1; dx++) {
				for (int dy = -1; dy <= 1; dy++) {
					if (dx == 0 && dy == 0) continue;
					int front = a[x+dx][y+dy] == a[x][y] ? run[x+dx][y+dy][dir] : 0;
					int back  = a[x-dx][y-dy] == a[x][y] ? run[x-dx][y-dy][7-dir] : 0;
					int cur = front+back+1;
					
					run[x+front*dx][y+front*dy][7-dir] = cur;
					if (cur >= k) {
						System.out.println((char)('A'+i%2) + " " + (i+1));
						return;
					}

					dir++;
				}
			}
		}
		System.out.println('D');
	}
}
