import java.io.*;

public class GregorsBuffered {
    public static void main(String[] args) throws IOException {
    	InputStreamReader r = new InputStreamReader(System.in); 
    	BufferedReader in = new BufferedReader(r);
		String line = in.readLine();
		String[] parts = line.split(" ");
		int n = Integer.parseInt(parts[0]); 
		int l = Integer.parseInt(parts[1]);
        String[] words = new String[n];
        int[][] pref = new int[n][l];
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < l; ++j)
                pref[i][j] = l+1;
        int[] maxInCol = new int[l];
        for (int i = 0; i < maxInCol.length; ++i)
            maxInCol[i] = -1;
        for (int i = 0; i < n; ++i)
            words[i] = in.readLine();
        for (int i = 0; i < n-1; ++i)
        {
            String x = words[i];
            String y = words[i+1];
            int[] z = pref[i];
            for (int j = l-1; j >= 0; --j)
            {
                if (x.charAt(j) < y.charAt(j))
                    z[j] = 1;
                else if (x.charAt(j) == y.charAt(j) && j != l-1 && z[j+1] != l+1)
                    z[j] = z[j+1] + 1;
            }
        }
        for (int i = 0; i < l; ++i)
            for (int j = 0; j < n-1; ++j)
                maxInCol[i] = Math.max(maxInCol[i],pref[j][i]);
        int pos = -1;
        for (int i = 0; i < maxInCol.length; ++i)
            if (pos == -1 || maxInCol[i] < maxInCol[pos])
                pos = i;
        System.out.println((pos + 1) + " " + (pos + maxInCol[pos]));
    }
}
