#include <bits/stdc++.h>
using namespace std;

vector<int> pos;
vector<vector<int>> a;

const vector<pair<int,int>> dirs = {{0,1}, {1,-1}, {1,0}, {1,1}};

int owner(int x, int y, int t) {
	if (a[x][y] == 0) return 0;
	return a[x][y] <= t ? 1 + a[x][y]%2 : 0;
}

int main() {
	int h, w, k;
	cin >> h >> w >> k;

	pos.resize(w+2);
	a.resize(h+2, vector<int>(w+2));
	
	for (int i = 1; i <= h*w; i++) {
		int c; cin >> c;
		a[++pos[c]][c] = i;
	}
	
	int tmin = 0, tmax = h*w+1;
	while (tmax-tmin > 1) {
		int t = (tmin+tmax)/2;
		
		bool done = false;
		for (auto [dx,dy] : dirs) {
			for (int x = 1; x <= h; x++) {
				for (int y = 1; y <= w; y++) {
					if (owner(x, y, t) && owner(x, y, t) != owner(x-dx, y-dy, t)) {
						int len = 1;
						while (owner(x, y, t) == owner(x+len*dx, y+len*dy, t)) len++;
						if (len >= k) done = true;
					}
				}
			}
		}
		(done ? tmax : tmin) = t;
	}
	
	if (tmax == h*w+1) cout << "D" << endl;
	else cout << char('A' + tmin%2) << " " << tmax << endl;
}
