#include <bits/stdc++.h>
using namespace std;

int window, res;
vector<int> a;

void process_line(int start, int jump, int count) {
	if (count < window) return;

	for (int i = 0; i <= count-window; i++) {
		int parity = a[start + i*jump] % 2;
		bool ok = true;
		int latest = -1;
		for (int j = i; j < i+window; j++) {
			int x = a[start + j*jump];
			if (x%2 != parity) {
				ok = false;
				break;
			}
			latest = max(latest, x);
		}
		if (ok) res = min(res, latest);
	}
}

int main() {
	int h, w;
	cin >> h >> w >> window;

	vector<int> pos(w);
	a.resize(h*w);
	
	for (int k = 0; k < h*w; k++) {
		int j; cin >> j;
		int i = pos[--j]++;
		a[i*w+j] = k;
	}
	
	res = h*w;
	for (int i = 0; i < h; i++) {
		process_line(i*w, 1, w);		
		process_line(i*w, w+1, min(w,h-i));
		process_line((i+1)*w-1, w-1, min(w,h-i));
	}
	for (int j = 0; j < w; j++) {
		process_line(j, w, h);
		process_line(j, w+1, min(h,w-j));
		process_line(j, w-1, min(h,j+1));
	}

	if (res == h*w) cout << "D" << endl;
	else cout << "AB"[res%2] << " " << res+1 << endl;
}
